%define name		clamav
%define version		0.61
%define snap		20030829
%define release		0.%{snap}.1mdk

%define mpc_version	0.13
%define mpc_release	1mdk
%define rversion	0.61
%define rrelease	0.%{snap}.1mdk

%define	major		1
%define libname	%mklibname %{name} %{major}

Name:			%{name}
Summary:		An anti-virus utility for Unix.
Version:		%{version}
Release:		%{release}
#Source0:		%{name}-%{version}.tar.gz
#Source1:		%{name}-%{version}.tar.gz.sig
Source0:		%{name}-%{snap}.tar.bz2
Source2:		%{name}.init.bz2
Source3:		%{name}-milter.init.bz2
Source4:		%{name}-milter.sysconfig.bz2
Source5:		freshclam.cron.bz2
Source6:		freshclam.logrotate.bz2
Source7:		%{name}.logrotate.bz2
Source8:		clamdmail-%{mpc_version}.tar.bz2
Patch0:			%{name}-0.61-config.patch.bz2
Patch1:			clamav-20030806-mirrors.txt.diff.bz2
URL:			http://clamav.sourceforge.net/
License:		GPL
Group:			File tools
Requires:		%{libname} = %{version}-%{release}
Requires:		%{name}-db
PreReq:			rpm-helper
BuildRequires:		bzip2-devel
BuildRequires:		sendmail-devel
BuildRequires:		zlib-devel
BuildRequires:		wget
Provides:		virusscanner AV-Scanner
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description 
Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose
of this software is the integration with mail servers (attachment
scanning). The package provides a flexible and scalable
multi-threaded daemon, a commandline scanner, and a tool for
automatic updating via Internet. The programs are based on a
shared library distributed with the Clam AntiVirus package, which
you can use in your own software. 

%package -n		clamd
Summary:		The Clam AntiVirus Daemon
Group:			System/Servers
Requires:		%{libname} = %{version}-%{release}
Requires:		%{name} = %{version}-%{release}
Requires:		%{name}-db
PreReq:			rpm-helper
Provides:		virusscanner-daemon AV-Scanner-Daemon

%description -n		clamd
The Clam AntiVirus Daemon

%package -n		%{name}-milter
Summary:		The Clam AntiVirus sendmail-milter Daemon
Group:			System/Servers
Requires:		%{libname} = %{version}-%{release}
Requires:		%{name} = %{version}-%{release}
Requires:		%{name}-db
Requires:		clamd = %{version}-%{release}
Requires:		sendmail
PreReq:			rpm-helper

%description -n		%{name}-milter
The Clam AntiVirus sendmail-milter Daemon

%package -n		%{name}-db
Summary:		Virus database for %{name}
Group:			Databases
Requires:		%{libname} = %{version}-%{release}
Requires:		%{name} = %{version}-%{release}
PreReq:			rpm-helper

%description -n		%{name}-db
The actual virus database for %{name}

%package -n		%{libname}
Summary:		Shared libraries for %{name}
Group:          	System/Libraries

%description -n		%{libname}
Shared libraries for %{name}

%package -n		%{libname}-devel
Summary:		Development library and header files for the %{name} library
Group:			Development/C
Requires:		%{libname} = %{version}-%{release}
Provides:		%{name}-devel lib%{name}-devel
Obsoletes:		%{name}-devel lib%{name}-devel

%description -n		%{libname}-devel
This package contains the static %{libname} library and its header
files.

%package -n		%{libname}-static-devel
Summary:		Static development library for the %{name} library
Group:			Development/C
Requires:		%{libname}-devel = %{version}-%{release}
Provides:		%{name}-static-devel lib%{name}-static-devel
Obsoletes:		%{name}-static-devel lib%{name}-static-devel

%description -n		%{libname}-static-devel
This package contains the static %{libname} library.

%package -n		clamdmail
Summary:		ClamAV Daemon Mail Processing Client
Version:		%{mpc_version}
Release:		%{mpc_release}
Group:			System/Servers
Requires:		%{libname} = %{rversion}-%{rrelease}
Requires:		%{name} = %{rversion}-%{rrelease}
Requires:		%{name}-db

%description -n		clamdmail
Clamdmail works with SpamAssassin and ClamAV Anti-Virus to scan
mail at MTA level without loading a single perl library! A
limited, C-based alternative to Q-Scanner and Amavis.

Clamdmail is designed for use with qmail but it will work with any
MTA (e.g. zmailer) that can be persuaded to pass mail to it on
stdout.

%prep
%setup -q -n %{name}-%{snap} -a8
%patch0 -p0
%patch1 -p0

bzcat %{SOURCE2} > clamd.init
bzcat %{SOURCE3} > %{name}-milter.init
bzcat %{SOURCE4} > %{name}-milter.sysconfig
bzcat %{SOURCE5} > freshclam.cron
bzcat %{SOURCE6} > freshclam.logrotate
bzcat %{SOURCE7} > %{name}.logrotate

# fetch the virus database files
wget http://clamav.sourceforge.net/database/viruses.db
wget http://clamav.sourceforge.net/database/viruses.md5
wget http://clamav.sourceforge.net/database/viruses.db2
wget http://clamav.sourceforge.net/database/viruses2.md5
md5sum -c viruses.md5 && md5sum -c viruses2.md5

%build

%serverbuild

%configure2_5x \
    --enable-milter \
    --disable-%{name} \
    --with-user=%{name} \
    --with-group=%{name} \
    --with-dbdir=%{_localstatedir}/%{name}

%make 

ln -s ../%{name}-%{snap} ./clamav
pushd clamdmail-%{mpc_version}
%configure2_5x \
    --disable-%{name} \
    --with-user=%{name} \
    --with-group=%{name} \
    --with-dbdir=%{_localstatedir}/%{name}

%make 
popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%makeinstall_std

# install the init scripts
install -d %{buildroot}%{_initrddir}
install -m755 clamd.init %{buildroot}%{_initrddir}/clamd
install -m755 %{name}-milter.init %{buildroot}%{_initrddir}/%{name}-milter

# install the milter config
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m644 %{name}-milter.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/%{name}-milter

# install the cron script to auto update the virus database 
install -d %{buildroot}%{_sysconfdir}/cron.daily
install -m755 freshclam.cron %{buildroot}%{_sysconfdir}/cron.daily/freshclam

# install the logrotate stuff
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -m644 freshclam.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/freshclam
install -m644 %{name}.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

install -d %{buildroot}/var/log/%{name}
touch %{buildroot}/var/log/%{name}/freshclam.log
touch %{buildroot}/var/log/%{name}/clamd.log

# huh? a bug?
install -m644 etc/%{name}.conf %{buildroot}%{_sysconfdir}/%{name}.conf

# pid file dir
install -d %{buildroot}/var/run/%{name}

# install clamdmail
pushd clamdmail-%{mpc_version}
%makeinstall_std
popd

# install (missing) virus database files
install -m0644 viruses.db %{buildroot}%{_localstatedir}/%{name}/
install -m0644 viruses.db2 %{buildroot}%{_localstatedir}/%{name}/

%pre
%_pre_useradd %{name} %{_localstatedir}/%{name} /bin/sh

%pre -n clamd
%_pre_useradd %{name} %{_localstatedir}/%{name} /bin/sh

%post -n clamd
%_post_service clamd
%create_ghostfile /var/log/%{name}/clamd.log %{name} %{name} 0644

%preun -n clamd
%_preun_service clamd

%postun -n clamd
%_postun_userdel %{name}

%post -n %{name}-milter
%_post_service %{name}-milter

%preun -n %{name}-milter
%_preun_service %{name}-milter

%pre -n %{name}-db
%_pre_useradd %{name} %{_localstatedir}/%{name} /bin/sh

%post -n %{name}-db
%create_ghostfile /var/log/%{name}/freshclam.log %{name} %{name} 0644

%postun -n %{name}-db
%_postun_userdel %{name}

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%post -n %{libname}-devel -p /sbin/ldconfig
%postun -n %{libname}-devel -p /sbin/ldconfig

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc AUTHORS BUGS ChangeLog FAQ NEWS README TODO test
%doc docs/DMS/* docs/FreeBSD-HowTo/* docs/clamdoc.*
%doc docs/html docs/Japanese docs/Portugese docs/Spanish
%doc contrib/trashscan/trashscan-0.08.tar.gz
%doc contrib/clamdb/clamdb.zip
%{_bindir}/clamscan
%{_bindir}/freshclam
%{_bindir}/sigtool
%{_mandir}/man1/sigtool.1*
%{_mandir}/man1/clamscan.1*
%{_mandir}/man1/freshclam.1*

%files -n clamd
%defattr(-,root,root)
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/%{name}.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%attr(0755,root,root) %config(noreplace) %{_initrddir}/clamd
%{_sbindir}/clamd
%{_bindir}/clamdscan
%{_mandir}/man5/%{name}.conf.5*
%{_mandir}/man8/clamd.8*
%{_mandir}/man1/clamdscan.1*
%dir %attr(0755,%{name},%{name}) /var/run/%{name}
%dir %attr(0755,%{name},%{name}) %{_localstatedir}/%{name}
%dir %attr(0755,%{name},%{name}) /var/log/%{name}
%ghost %attr(0644,%{name},%{name}) /var/log/%{name}/clamd.log

%files -n clamdmail
%defattr(-,root,root)
%doc clamdmail-%{mpc_version}/USAGE
%doc clamdmail-%{mpc_version}/qmail
%doc clamdmail-%{mpc_version}/README
%doc clamdmail-%{mpc_version}/CHANGELOG
%doc clamdmail-%{mpc_version}/AUTHORS
%doc clamdmail-%{mpc_version}/INSTALL
%{_bindir}/clamdmail

%files -n %{name}-milter
%defattr(-,root,root)
%doc %{name}-milter/INSTALL
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/%{name}-milter
%attr(0755,root,root) %config(noreplace) %{_initrddir}/%{name}-milter
%{_sbindir}/%{name}-milter
%{_mandir}/man1/%{name}-milter.1*

%files -n %{name}-db
%defattr(-,root,root)
%attr(0755,root,root) %config(noreplace) %{_sysconfdir}/cron.daily/freshclam
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/freshclam
%dir %attr(0755,%{name},%{name}) %{_localstatedir}/%{name}
%attr(0644,%{name},%{name}) %config(noreplace) %{_localstatedir}/%{name}/viruses.db*
%attr(0644,%{name},%{name}) %config(noreplace) %{_localstatedir}/%{name}/mirrors.txt
%ghost %attr(0644,%{name},%{name}) /var/log/%{name}/freshclam.log

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/*.la

%files -n %{libname}-static-devel
%defattr(-,root,root)
%{_libdir}/*.a

%changelog
* Sat Sep 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.61-0.20030829.1mdk
- use the 20030829 snapshot
- remove patches that's included in the upstream source
- changed P3 to P1
- fix S7 and log stuff in the spec file
- fetch virus databases as these are not included
- clamdmail-0.13
- fix buildrequires

* Mon Aug 25 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.61-0.20030806.2mdk
- use the correct 20030806 snapshot
- added P1 to fix stale sockets if unclean shutdown.
- added P2 to fix cli_malloc build error
- update url
- update url in mirrors.txt file (P3)

* Tue Aug 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.61-0.20030806.1mdk
- use the 20030806 snapshot
- added 2 files from contrib into docdir

* Tue Aug 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.61-0.20030705.5mdk
- spec file work around for rpm stupidity...

* Tue Aug 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.61-0.20030705.4mdk
- added the clamdmail subpckage

* Tue Jul 29 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.61-0.20030705.3mdk
- use some more spec file voodoo magic to please distlint (a bit?)

* Sat Jul 19 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.61-0.20030705.2mdk
- change description on request by the author

* Wed Jul 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.61-0.20030705.1mdk
- use the 20030705 snapshot
- added some more docs

* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.60-2mdk
- rebuild
- misc spec file fixes

* Sun Jun 22 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.60-1mdk
- misc fixes by mutt@free.fr:
  - upgrade to 0.60 (clamav-0.54-buffer_overflow_fix included)
  - doc changes (Spanish, Japanese), new file mirrors.txt
- added the clamav-milter sub package (S3 & S4)
- added cron script to auto update the virus database, plus a logrotate
  configuration file (S5 & S6)
- use the %%configure2_5x macro
- fix buildrequires
- rediff P0
- move logs to /var/log/clamav/ (msec fix)
- misc spec file fixes

* Sat May 31 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.54-8mdk
- rebuilt to have rpm v4.2 pick up provides

* Thu Mar 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.54-7mdk
- fix potential security hole (P1) as in:
  http://archive.elektrapro.com/clamav.elektrapro.com/users/2003/3/msg00016.html

* Thu Mar 06 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.54-6mdk
- use the %%mklibname macro
- misc spec file fixes
- fix pid file location
- got rpmlint a little happier...

* Thu Jan 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.54-5mdk
- build release

* Fri Nov 22 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.54-4mdk
- argh!!! viruscanner should spell virusscanner, right?

* Fri Nov 22 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.54-3mdk
- added virtual provides (pointed out by Buchan Milne)
  clamav Provides: viruscanner AV-Scanner
  clamd Provides: viruscanner-daemon AV-Scanner-Daemon

* Fri Nov 22 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.54-2mdk
- fix %%_pre_useradd (pointed out by Buchan Milne)
- also fix ldconfig in %%post %%postun (wierd...)

* Thu Nov 21 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.54-1mdk
- new version
- updated P0
- %{_bindir}/clamdscan was added to the clamd package
- misc spec file fixes

* Fri Nov 01 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.53-1mdk
- new version

* Tue Oct 29 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.52-1mdk
- new version
- misc spec file fixes

* Sat Oct 19 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.51-3mdk
- attrib 711 on %{_localstatedir}/clamav was too restrictive for
  qmail-scanner, changed that to 755

* Mon Oct 14 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.51-2mdk
- fixed Group=File tools for main package (correct?)

* Wed Oct 09 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.51-1mdk
- new version
- libifictions and daemonification
- major spec file fixes

* Thu Aug 22 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.24-1mdk
- new version
- added GnuPG signature
- misc spec file fixes

* Sat Aug  3 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.23-1mdk
- new version

* Wed Jul 24 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.22-1mdk
- new version

* Thu Jul 18 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.21-1mdk
- new version

* Tue Jul 16 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.20-1mdk
- new version, new url
- misc spec file fixes

* Wed Jun 12 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.15-1mdk
- new version

* Sat Jun  1 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.14-1mdk
- new version
- remove P0

* Sat May 11 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.11-1mdk
- initial cooker contrib
